import { Program } from '@babel/types';
import { MagicString } from './magic-string.js';
import { SFCScriptBlock, SFCDescriptor, SFCParseResult } from '@vue/compiler-sfc';
import 'magic-string';

type _SFCScriptBlock = Omit<SFCScriptBlock, 'scriptAst' | 'scriptSetupAst'>;
type SFC = Omit<SFCDescriptor, 'script' | 'scriptSetup'> & {
    sfc: SFCParseResult;
    script?: _SFCScriptBlock | null;
    scriptSetup?: _SFCScriptBlock | null;
    lang: string | undefined;
    getScriptAst(): Program | undefined;
    getSetupAst(): Program | undefined;
} & Pick<SFCParseResult, 'errors'>;
declare function parseSFC(code: string, id: string): SFC;
declare function getFileCodeAndLang(code: string, id: string): {
    code: string;
    lang: string;
};
declare function addNormalScript({ script, lang }: SFC, s: MagicString): {
    start(): number;
    end(): void;
};

export { SFC, _SFCScriptBlock, addNormalScript, getFileCodeAndLang, parseSFC };
